//===========================================================
//=     University of Illinois at Urbana/Champaign          =
//=     Department of Computer Science                      =
//=     Dr. Dan Roth - Cognitive Computation Group          =
//=                                                         =
//=  Project: Snow                                          =
//=                                                         =
//=   Module: TargetIdSet.cpp                               =
//=  Version: 2.1                                           =
//=  Authors: Jeff Rosen and Andrew Carlson                 =
//=     Date: xx/xx/99                                      = 
//=                                                         =
//= Comments:                                               =
//===========================================================

#include "TargetIdSet.h"
#include <iostream>
#include <string>
#include <algorithm>

void TargetIdSet::Show()
{
    const_iterator it = begin();
    const_iterator end = this->end();
    while (it != end)
    {
        cout << *it;
        it++;
        if (it != end)
        {
            cout << ", ";
        }
    }

    cout << endl;
}

bool TargetIdSet::Parse( const char* in )
{
    string temp;
    bool result = true;
    
    clear();

    try
    {
        //if (in[0] != '(')
        //{
        //    throw "Target specification not in allowed format";
        //}
    
        //string work(in + 1);
        string work(in);
        FeatureID l, h;
        char* pDelim, delim;

        do {
            l = strtoul(work.c_str(), &pDelim, 10);
            // Did some conversion take place?
            if (pDelim != work.c_str())
            {
                // Is this a range or single ID?
                if (*pDelim == '-')
                {
                    work = string(pDelim + 1);
                    h = strtoul(work.c_str(), &pDelim, 10);
                    if (pDelim == work.c_str())
                    {
                        temp = "Problem found parsing target specification: '";
                        temp += in;
                        temp += "'";
                        throw temp.c_str();
                    }
                } else {
                    h = l;
                }
                while (l <= h)
                {
                    insert(l);
                    l++;
                }

                // Save delim and update work
                delim = *pDelim;
                work = string(pDelim + 1);
            } else {
                temp = "Problem found parsing example: '";
                temp += in;
                temp += "'";
                throw temp.c_str();
            }
        } while (delim == ',');

        //if (delim != ')')
        //{
        //    throw "Example not in allowed format";
        //}
    }
    catch( const char* error )
    {
        cerr << error << endl;
        result = false;
    }
        
    return result;
}






